export declare type IInstanceInitializer<IContainer, N extends keyof IContainer> = (instance: IContainer[N], container: IContainer, name?: N) => void;
export declare type VoidFn = () => void;
export declare type IFactory<IContainer, N extends keyof IContainer> = (container: IContainer) => IContainer[N];
export declare type IFactoryTuple<IContainer, N extends keyof IContainer> = [IFactory<IContainer, N>, IInstanceInitializer<IContainer, N>];
export declare type IFactories<IContainer extends object> = {
    [name in keyof IContainer]: IFactory<IContainer, name> | IFactoryTuple<IContainer, name>;
};
export declare type IPureFactories<C> = {
    [name in keyof C]: () => C[name];
};
